<template>
  <MenuBar>
    <el-tabs type="border-card" v-model="mainTabActive" @tab-change="handleTabClick" stretch>
      <el-tab-pane name="first">
        <template #label>
                    <div v-if="mainTabActive == 'first'" class="flex items-center gap-sm" >
                    <el-icon><Loading /></el-icon>
                    <h1>Ongoing Orders</h1>
                    </div>
                    <p v-else>Ongoing Orders</p>
                </template>
        <div class="flex items-center margin-bottom-sm">
          <el-button @click="refreshOngoing">
            <el-icon>
              <RefreshRight />
            </el-icon>
          </el-button>

          <el-select class="margin-left-sm" v-model="ongoingSelectedStatus" size="large">
            <el-option v-for="option in ongoingStatusOptions" :key="option.value" :label="option.label"
              :value="option.value" />
          </el-select>
        </div>


        <div class="flex items-center items-start items-justify flex-wrap gap-md"
          v-loading="transactionLoading">
          <h1 class="font-size-lg color-dynamic-black" v-if="data?.transactions?.length <= 0">No data</h1>

          <template v-for="item in filteredTransactions">
            <el-card style="width: 500px">
              <el-collapse accordion>
                <el-collapse-item size="large" name="1">
                  <template #title>
                    <div class="full-width flex items-space-between items-center">
                      <h1 class="font-size-md">Order#{{ item.id }}</h1>
                      <el-tag :class="item.transaction_status.title.toLowerCase().split(' ').join('-')" effect="dark"
                        round size="medium">
                        {{ item.transaction_status.title }}
                      </el-tag>
                    </div>
                  </template>

                  <el-collapse accordion>
                    <el-collapse-item size="large" name="1">
                      <template #title>
                        <div class="full-width flex items-space-between items-center">
                          <h1 class="font-size-sm">Track order</h1>
                        </div>
                      </template>
                      <div style="height: 200px">
                        <el-steps class="margin-top-sm margin-bottom-md padding-sm" :active="item.transaction_status.id"
                          direction="vertical" finish-status="success" style="height: 190px; overflow-y:auto">

                          <el-step title="Pending" :icon="Stopwatch" :description="item.pending_at" />
                          <el-step title="Processing" :icon="Loading" :description="item.processing_at" />
                          <el-step title="Delivering" :icon="Van" :description="item.delivering_at" />
                          <el-step title="Orders Received" :icon="Check" :description="item.completed_at" />

                          <template v-if="transactionCondition(item.transaction_status.id, [5, 6, 7, 8])">
                            <el-step title="Return Request" :icon="Memo" :description="item.to_return_requested_at" />
                            <el-step title="Request Accepted" :icon="DocumentChecked"
                              :description="item.to_return_accepted_at" />
                            <el-step title="Return Processing" :icon="Loading" :description="item.to_return_process_at" />
                            <el-step title="Return Completed" :icon="Check" :description="item.return_completed_at" />
                          </template>

                          <template v-else>
                            <el-step title="Rejected" :icon="CircleCloseFilled" :description="item.rejected_at" />
                          </template>

                        </el-steps>
                      </div>
                    </el-collapse-item>
                  </el-collapse>

                  <el-collapse accordion>
                    <el-collapse-item size="large" name="1">
                      <template #title>
                        <div class="full-width flex items-space-between items-center">
                          <h1 class="font-size-sm">View Orders</h1>
                        </div>
                      </template>

                      <el-table :data="item.orders" height="200" show-summary>
                        <el-table-column prop="item.name" label="Product" />
                        <el-table-column prop="quantity" label="Quantity" />
                        <el-table-column prop="item.price" label="Price" />
                        <el-table-column prop="item_sub_total" label="Sub Total" />
                      </el-table>
                    </el-collapse-item>
                  </el-collapse>

                  <el-collapse accordion v-if="item.payment_method == 'gcash'">
                    <el-collapse-item size="large" name="1">
                      <template #title>
                        <div class="full-width flex items-space-between items-center">
                          <h1 class="font-size-sm">Transaction Proof</h1>
                        </div>
                      </template>
                      <el-image
                        style="width: 500px; height: 500px"
                        :src="'/online_transactions/' + item.proof_of_payment"
                        fit="cover"
                      />
                    </el-collapse-item>
                  </el-collapse>

                </el-collapse-item>
              </el-collapse>
              <div class="flex items-space-between" v-if="item.to_return_comment">
                <h1 class="font-size-sm">To Return Reason </h1>
                <p class="font-size-sm">{{ item.to_return_comment }}</p>
              </div>

              <h1 class="font-size-sm">
                Total Summary
              </h1>
              <div class="full-width flex items-space-between items-center">
                <h1 class="font-size-sm">
                  Subtotal
                </h1>
                <p class="font-size-sm">
                  ₱{{ item.overall_total }}
                </p>
              </div>

              <div class="full-width flex items-space-between items-center">
                <h1 class="font-size-sm">
                  Shipping Fee
                </h1>
                <p class="font-size-sm">
                  ₱{{ item.shipping_fee }}
                </p>
              </div>
              <hr />
              <div class="full-width flex items-space-between items-center">
                <h1 class="font-size-sm">
                  Total
                </h1>
                <h1 class="font-size-sm">
                  ₱{{ item.overall_total + item.shipping_fee }}
                </h1>
              </div>
              <h1 class="font-size-sm">
                {{ item.payment_method == 'cod' ? 'Paid by Cash on Delivery' : 'Paid by GCash' }}
              </h1>

              <el-button v-if="item.transaction_status.id === 1" type="danger" @click="cancelOrder(item.id)">
                Cancel Order
              </el-button>

              <el-button type="success" @click="ordersReceived(item.id)" v-if="item.transaction_status.id === 3">
                Orders Received
              </el-button>

              <el-button type="danger" @click="requestToReturn(item.id)" v-if="item.transaction_status.id === 4">
                Request to Return Item
              </el-button>

              <el-button type="success" @click="endTransaction(item.id)" v-if="item.transaction_status.id === 4">
                End Transaction
              </el-button>


            </el-card>
          </template>

        </div>

      </el-tab-pane>

      <el-tab-pane name="second">
      <template #label>
                    <div v-if="mainTabActive == 'second'" class="flex items-center gap-sm">
                    <el-icon><SuccessFilled /></el-icon>
                    <h1 >Finished Orders</h1>
                    </div>
                    <p v-else>Finished Orders</p>
                </template>
        <div class="flex items-center margin-bottom-sm">
          <el-button @click="refreshFinished">
            <el-icon>
              <RefreshRight />
            </el-icon>
          </el-button>

          <el-select class="margin-left-sm" v-model="finishedSelectedStatus" size="large">
            <el-option v-for="option in finishedStatusOptions" :key="option.value" :label="option.label"
              :value="option.value" />
          </el-select>

          <el-select class="margin-left-sm" v-model="sortBy" size="large">
            <el-option v-for="option in sortingOptions" :key="option.value" :label="option.label"
              :value="option.value" />
          </el-select>
        </div>


        <div class="flex items-start items-justify flex-wrap gap-md" v-loading="transactionLoading">
          <h1 class="font-size-lg color-dynamic-black" v-if="finishedData?.transactions?.length <= 0">No data</h1>

          <template v-for="item in computedProperty2">
            <el-card style="width: 500px">
              <el-collapse accordion>
                <el-collapse-item size="large" name="1">
                  <template #title>
                    <div class="full-width flex items-space-between items-center">
                      <h1 class="font-size-md">Order#{{ item.id }}</h1>
                      <el-tag :class="item.transaction_status.title.toLowerCase().split(' ').join('-')" effect="dark"
                        round size="medium">
                        {{ item.transaction_status.title }}
                      </el-tag>
                    </div>
                  </template>

                  <el-collapse accordion>
                    <el-collapse-item size="large" name="1">
                      <template #title>
                        <div class="full-width flex items-space-between items-center">
                          <h1 class="font-size-sm">Track order</h1>
                        </div>
                      </template>
                      <div
                        :style="!transactionCondition(item.transaction_status.id, [10, 11]) ? 'height: 200px;' : 'height: 120px;'">
                        <el-steps class="margin-top-sm margin-bottom-md padding-sm" :active="item.transaction_status.id"
                          direction="vertical" finish-status="success"
                          :style="!transactionCondition(item.transaction_status.id, [10, 11]) ? 'height: 200px; overflow-y:scroll' : 'height: 120px;'">
                          <el-step title="Pending" :icon="Stopwatch" :description="item.pending_at" />

                          <template v-if="!transactionCondition(item.transaction_status.id, [10, 11])">
                            <el-step title="Processing" :icon="Loading" :description="item.processing_at" />

                            <el-step title="Delivering" :icon="Van" :description="item.delivering_at" />
                            <el-step title="Orders Received" :icon="Check" :description="item.completed_at" />

                            <template v-if="item.transaction_status.id >= 5">
                              <el-step title="Return Request" :icon="Memo" :description="item.to_return_requested_at" />

                              <template v-if="!transactionCondition(item.transaction_status.id, [9])">
                                <el-step title="Request Accepted" :icon="DocumentChecked"
                                  :description="item.to_return_accepted_at" />
                                <el-step title="Return Processing" :icon="Loading"
                                  :description="item.to_return_process_at" />
                                <el-step title="Return Completed" :icon="Check" :description="item.return_completed_at" />
                              </template>
                            </template>
                          </template>
                          <template v-else>
                            <el-step v-if="transactionCondition(item.transaction_status.id, [10])" title="Rejected"
                              :icon="CircleCloseFilled" :description="item.rejected_at" />
                            <el-step v-if="transactionCondition(item.transaction_status.id, [11])" title="Canceled"
                              :icon="CircleCloseFilled" :description="item.canceled_at" />
                          </template>

                        </el-steps>
                      </div>
                    </el-collapse-item>
                  </el-collapse>

                        <el-collapse accordion v-if="item.payment_method == 'gcash'">
                    <el-collapse-item size="large" name="1">
                      <template #title>
                        <div class="full-width flex items-space-between items-center">
                          <h1 class="font-size-sm">Transaction Proof</h1>
                        </div>
                      </template>
                      <el-image
                        style="width: 500px; height: 500px"
                        :src="'/online_transactions/' + item.proof_of_payment"
                        fit="cover"
                      />
                    </el-collapse-item>
                  </el-collapse>

                  <el-collapse accordion>
                    <el-collapse-item size="large" name="1">
                      <template #title>
                        <div class="full-width flex items-space-between items-center">
                          <h1 class="font-size-sm">View Orders</h1>
                        </div>
                      </template>

                      <el-table :data="item.orders" height="200" show-summary>
                        <el-table-column prop="item.name" label="Product" />
                        <el-table-column prop="quantity" label="Quantity" />
                        <el-table-column prop="item.price" label="Price" />
                        <el-table-column prop="item_sub_total" label="Sub Total" />
                      </el-table>
                    </el-collapse-item>
                  </el-collapse>

            


                  <el-collapse accordion>
                    <el-collapse-item size="large" name="1">
                      <template #title>
                        <div class="full-width flex items-space-between items-center">
                          <h1 class="font-size-sm">Order Summary</h1>
                        </div>
                      </template>


                      <div v-if="item.to_return_comment" class="full-width flex items-space-between items-center">
                <h1 class="font-size-sm">
                  Return note
                </h1>
                <p class="font-size-sm">
                  {{ item.to_return_comment }}
                </p>
              </div>

              <div v-if="item.canceled_comment" class="full-width flex items-space-between items-center">
                <h1 class="font-size-sm">
                  {{ item.to_return_comment ? "Return rejected note" : "Cancel note" }}
                </h1>
                <p class="font-size-sm">
                  {{ item.canceled_comment }}
                </p>
              </div>
              <h1 class="font-size-sm">
                Total Summary
              </h1>
              <div class="full-width flex items-space-between items-center">
                <h1 class="font-size-sm">
                  Subtotal
                </h1>
                <p class="font-size-sm">
                  ₱{{ item.overall_total }}
                </p>
              </div>

              <div class="full-width flex items-space-between items-center">
                <h1 class="font-size-sm">
                  Shipping Fee
                </h1>
                <p class="font-size-sm">
                  ₱{{ item.shipping_fee }}
                </p>
              </div>
              <hr />
              <div class="full-width flex items-space-between items-center">
                <h1 class="font-size-sm">
                  Total
                </h1>
                <h1 class="font-size-sm">
                  ₱{{ item.overall_total + item.shipping_fee }}
                </h1>
              </div>
              <h1 class="font-size-sm">
                {{ item.payment_method == 'cod' ? 'Paid by Cash on Delivery' : 'Paid by GCash' }}
              </h1>
              </el-collapse-item>

                  </el-collapse>

                </el-collapse-item>
              </el-collapse>
           
            </el-card>
          </template>

        </div>


      </el-tab-pane>

    </el-tabs>

  </MenuBar>
</template>


<script setup>
import { ref, computed, onMounted, onBeforeUnmount } from "vue";

import { Stopwatch, Loading, Van, Check, Memo, RefreshRight, DocumentChecked, CircleCloseFilled, SuccessFilled } from "@element-plus/icons-vue";

import { ElMessage, ElMessageBox } from "element-plus";

import transactionHandler from "../../helpers/transactionHandler";

const { transactionLoading, fetchOrders, finishOrder, ongoingStatusOptions, finishedStatusOptions, sortingOptions } = transactionHandler;

const loading = ref();


const srcList = [
  'https://fuss10.elemecdn.com/a/3f/3302e58f9a181d2509f3dc0fa68b0jpeg.jpeg',
  'https://fuss10.elemecdn.com/1/34/19aa98b1fcb2781c4fba33d850549jpeg.jpeg',
  'https://fuss10.elemecdn.com/0/6f/e35ff375812e6b0020b6b4e8f9583jpeg.jpeg',
  'https://fuss10.elemecdn.com/9/bb/e27858e973f5d7d3904835f46abbdjpeg.jpeg',
  'https://fuss10.elemecdn.com/d/e6/c4d93a3805b3ce3f323f7974e6f78jpeg.jpeg',
  'https://fuss10.elemecdn.com/3/28/bbf893f792f03a54408b3b7a7ebf0jpeg.jpeg',
  'https://fuss10.elemecdn.com/2/11/6535bcfb26e4c79b48ddde44f4b6fjpeg.jpeg',
]


const data = ref([]);
const finishedData = ref([]);
const mainTabActive = ref('first');

const handleTabClick = async (tab, event) => {
    if(mainTabActive.value == 'first'){
        await fetchOrders(data, "user", "ongoing");
    }else if(mainTabActive.value == 'second'){
        await fetchOrders(finishedData, "user", "finished");
    }
}

const transactionCondition = (id, valuesToCheck) => {
  return (valuesToCheck.includes(id));
}

const refreshOngoing = async () => {
  await fetchOrders(data, "user", "ongoing");
}

const refreshFinished = async () => {
  await fetchOrders(finishedData, "user", "finished");
}


const cancelOrder = async (id) => {
  ElMessageBox.prompt("Are you sure you want to cancel this order#" + id + "? If so please provide a valid reason before we process your request.",
    "Warning", {
    confirmButtonText: 'OK',
    cancelButtonText: 'Cancel',
  }).then(async ({ value }) => {

    const cancelOrderUrl = "/api/finishTransaction"
    const cancelData = {
      id: id,
      new_transaction_id: 11,
      reject_comment: value
    }
    await finishOrder(cancelData);
    await fetchOrders(data, "user", "ongoing");
  });
}

const requestToReturn = (idParam) => {
  ElMessageBox.prompt("Are you sure you want to request a return for this order #" + idParam + "? Please provide a valid reason why would you like to return your order",
    "Warning", {
    confirmButtonText: 'OK',
    cancelButtonText: 'Cancel',
  }).then(async ({ value }) => {
    const requestData = {
      id: idParam,
      to_return_comment: value,
      transaction_status: 5
    };
    updateTransactionStatus(requestData)
  });
};

const ordersReceived = (idParam) => {
  ElMessageBox.confirm("Are you sure you received your order successfully? you can end the transaction afterwards or request a return if there is a problem with your order.",
    "Warning", {
    confirmButtonText: 'OK',
    cancelButtonText: 'Cancel',
  }).then(async ({ value }) => {
    const requestData = {
      id: idParam,
      to_return_comment: value,
      transaction_status: 4
    };
    updateTransactionStatus(requestData)
  });
}

const endTransaction = async (idParam) => {
  ElMessageBox.confirm("Are you sure you want to end this transaction? note that you can't ask for return and we will consider your transaction successful after confirming this message",
    "Warning", {
    confirmButtonText: 'OK',
    cancelButtonText: 'Cancel',
  }).then(async () => {
    const requestData = {
      id: idParam,
      new_transaction_id: 4
    };
    await finishOrder(requestData)
    await fetchOrders(data, "user", "ongoing");

  });
}

const updateTransactionStatus = async (requestData) => {
  try {
    const apiUrl = `/api/updateTransactStatus`;
    const headers = {
      Authorization: `Bearer ${localStorage.getItem("user_token") ??
        sessionStorage.getItem("user_token")
        }`,
    };

    await axios.post(apiUrl, requestData, {
      headers: headers,
    });
    await fetchOrders(data, "user", "ongoing");

  } catch (error) {
    console.error("Error updating transaction status:", error);
  }
};

const ongoingSelectedStatus = ref("");
const filteredTransactions = computed(() => {
    if (ongoingSelectedStatus.value === "") {
    return data.value.transactions;
    } else {
      return data.value.transactions.filter((transaction) => {
        return transaction.transaction_status.id == ongoingSelectedStatus.value;
      });
    }
});

const finishedSelectedStatus = ref("");
const sortBy = ref("");

const finishedFilteredTransactions = computed(() => {
  if (finishedSelectedStatus.value === "") {
    return finishedData.value.transactions;
  } else {
    return finishedData.value.transactions.filter((transaction) => {
      return transaction.transaction_status.id == finishedSelectedStatus.value;
    });
  }
});

const computedProperty2 = computed(() => {
  const filteredTransactions = finishedFilteredTransactions.value || []; // Use an empty array as the default
 
  
  if (sortBy.value == "1") {
    return [...filteredTransactions].sort((a, b) => {
      return new Date(b.created_at) - new Date(a.created_at);
    });
  } else if (sortBy.value == "2") {
    return [...filteredTransactions].sort((a, b) => {
      return new Date(b.updated_at) - new Date(a.updated_at);
    });
  } else {
    return [...filteredTransactions];
  }
});





onMounted(async () => {
  await fetchOrders(data, "user", "ongoing");

  Echo.channel('notification')
    .listen('MessageNotification', async (data) => {
        
        if(sessionStorage.getItem('user_id') == data.message){
          refreshOngoing();
        }
    });
})

onBeforeUnmount(async () => {
  Echo.leave('notification');
});


</script>
